<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:03 CET 2009 -->
<TITLE>
Executable
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.job.Executable interface">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="Executable";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/Executable.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../ch/javasoft/job/ExecJobProcessor.html" title="class in ch.javasoft.job"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../ch/javasoft/job/Executables.html" title="class in ch.javasoft.job"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?ch/javasoft/job/Executable.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Executable.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.job</FONT>
<BR>
Interface Executable&lt;R&gt;</H2>
<DL>
<DT><DT><B>Type Parameters:</B><DD><CODE>R</CODE> - The return value type of the result</DL>
<DL>
<DT><B>All Known Implementing Classes:</B> <DD><A HREF="../../../ch/javasoft/job/AbstractJob.html" title="class in ch.javasoft.job">AbstractJob</A>, <A HREF="../../../ch/javasoft/job/ExecJob.html" title="class in ch.javasoft.job">ExecJob</A>, <A HREF="../../../ch/javasoft/job/MultiJobExecutable.html" title="class in ch.javasoft.job">MultiJobExecutable</A>, <A HREF="../../../ch/javasoft/job/PipeJob.html" title="class in ch.javasoft.job">PipeJob</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public interface <A HREF="../../../src-html/ch/javasoft/job/Executable.html#line.49"><B>Executable&lt;R&gt;</B></A></DL>
</PRE>

<P>
The <code>Executable</code> is like a <A HREF="../../../ch/javasoft/job/Job.html" title="interface in ch.javasoft.job"><CODE>Job</CODE></A>, but the execution is
 not necessarily performed synchronous.
 <br/>
 The <A HREF="../../../ch/javasoft/job/Executable.html#exec()"><CODE>exec()</CODE></A> method does not wait until the job execution has 
 completed, and thus an execution monitor object is returned.
 <br/>
 The <A HREF="../../../ch/javasoft/job/Executable.html#execAndWait()"><CODE>execAndWait()</CODE></A> method blocks until completion and returns the
 result, which might also be an exception, thus a result object instead of the
 return value is returned.
<P>

<P>
<HR>

<P>

<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../ch/javasoft/job/JobMonitor.html" title="interface in ch.javasoft.job">JobMonitor</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/job/Executable.html#exec()">exec</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Executes and returns immediately, without waiting for completion.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../ch/javasoft/job/JobMonitor.html" title="interface in ch.javasoft.job">JobMonitor</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/job/Executable.html#exec(ch.javasoft.job.JobTerminationHandler)">exec</A></B>(<A HREF="../../../ch/javasoft/job/JobTerminationHandler.html" title="interface in ch.javasoft.job">JobTerminationHandler</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt;&nbsp;terminationHandler)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Executes and returns immediately, without waiting for completion.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../ch/javasoft/job/JobResult.html" title="interface in ch.javasoft.job">JobResult</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/job/Executable.html#execAndWait()">execAndWait</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Executes and waits for completion.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/job/Executable.html#execAndWaitThrowException()">execAndWaitThrowException</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Executes and waits for completion.</TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="exec()"><!-- --></A><H3>
exec</H3>
<PRE>
<A HREF="../../../ch/javasoft/job/JobMonitor.html" title="interface in ch.javasoft.job">JobMonitor</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt; <A HREF="../../../src-html/ch/javasoft/job/Executable.html#line.57"><B>exec</B></A>()</PRE>
<DL>
<DD>Executes and returns immediately, without waiting for completion.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the job monitor, which also allows access to the result
                        when execution completed</DL>
</DD>
</DL>
<HR>

<A NAME="exec(ch.javasoft.job.JobTerminationHandler)"><!-- --></A><H3>
exec</H3>
<PRE>
<A HREF="../../../ch/javasoft/job/JobMonitor.html" title="interface in ch.javasoft.job">JobMonitor</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt; <A HREF="../../../src-html/ch/javasoft/job/Executable.html#line.68"><B>exec</B></A>(<A HREF="../../../ch/javasoft/job/JobTerminationHandler.html" title="interface in ch.javasoft.job">JobTerminationHandler</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt;&nbsp;terminationHandler)</PRE>
<DL>
<DD>Executes and returns immediately, without waiting for completion. The 
 submitted termination handler is notified upon normal or exceptional
 termination.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>terminationHandler</CODE> - the handler for normal and exceptional termination of this job
<DT><B>Returns:</B><DD>the job monitor</DL>
</DD>
</DL>
<HR>

<A NAME="execAndWait()"><!-- --></A><H3>
execAndWait</H3>
<PRE>
<A HREF="../../../ch/javasoft/job/JobResult.html" title="interface in ch.javasoft.job">JobResult</A>&lt;<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A>&gt; <A HREF="../../../src-html/ch/javasoft/job/Executable.html#line.76"><B>execAndWait</B></A>()
                         throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/InterruptedException.html" title="class or interface in java.lang">InterruptedException</A></PRE>
<DL>
<DD>Executes and waits for completion.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the job result, giving access to the return value on success,
                        or to the exception if execution caused any.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/InterruptedException.html" title="class or interface in java.lang">InterruptedException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="execAndWaitThrowException()"><!-- --></A><H3>
execAndWaitThrowException</H3>
<PRE>
<A HREF="../../../ch/javasoft/job/Executable.html" title="type parameter in Executable">R</A> <A HREF="../../../src-html/ch/javasoft/job/Executable.html#line.85"><B>execAndWaitThrowException</B></A>()
                            throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/InterruptedException.html" title="class or interface in java.lang">InterruptedException</A>,
                                   <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Throwable.html" title="class or interface in java.lang">Throwable</A></PRE>
<DL>
<DD>Executes and waits for completion. The result is returned on normal
 termination, and an exception is thrown on abnormal (exceptional)
 termination.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the result if termination is normal
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/InterruptedException.html" title="class or interface in java.lang">InterruptedException</A></CODE>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Throwable.html" title="class or interface in java.lang">Throwable</A></CODE></DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/Executable.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../ch/javasoft/job/ExecJobProcessor.html" title="class in ch.javasoft.job"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../ch/javasoft/job/Executables.html" title="class in ch.javasoft.job"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?ch/javasoft/job/Executable.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Executable.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
